{"openapi":"3.0.1","info":{"title":"Coro Cybersecurity Public API","description":"<br/>This is the Coro Cybersecurity platform API specification reference.\n\nThis section provides a complete reference listing for the Coro Cybersecurity REST API resource model.\n\n### About the resource reference\n\nThis reference lists all the resources available through the Coro REST API.\n\nEach section relates to a specific resource and provides its name, description, unique URI path, and the list of operations you can perform on it.\n\nFor each operation, you can find:\n\n* A complete description of the action\n* Request parameters\n* A list of potential responses\n* Security (authentication) requirements\n\nThe portal also provides code samples and examples for making requests in a number of programming languages, together with samples of the possible response bodies.\n\nIn addition to this, Coro provides a **Try It** feature where you can interact with the API directly through the portal. To use **Try It**, you'll need to first obtain _Client ID_ and _Secret_ credentials; for more information, see [Authentication](/developer-portal/authentication/).","termsOfService":"https://coro.net/terms/","contact":{"url":"https://support.coro.net","email":"support@coro.net"},"version":"v1"},"servers":[{"url":"https://api.secure.coro.net","description":"Coro US API server target URL"}],"tags":[{"name":"audit-logs","description":"This is the audit log resource."},{"name":"authentication","description":"This is the resource for API authentication requests.<br/><br/>Use this resource to validate your identify and to obtain a bearer token to use when accessing other API resources."},{"name":"devices","description":"This is the Devices resource. <br/><br/>Use this resource to get details of all protected devices for a particular workspace."},{"name":"portal-users","description":"This is the portal user resource. <br/><br/>Use this resource to get details of all portal users added to the specified workspace."},{"name":"subscriptions","description":"This is the subscriptions resource. <br/><br/>Use this resource to view and manage workspace subscriptions."},{"name":"tickets","description":"This is the Tickets resource. <br/><br/>Use this resource to get details of all tickets stored in the Coro platform for a particular workspace."},{"name":"tickets-summary","description":"This is the Tickets Summary resource. <br/><br/>Use this resource to get details of tickets for a particular workspace, grouped by protection component."},{"name":"usage","description":"This is the resource for Coro usage.<br/><br/>Use this resource to obtain information about usage"},{"name":"users","description":"This is the protected user resource. <br/><br/>Use this resource to get details of all protected users added to the specified workspace."},{"name":"webhook-configuration","description":"Use this resource to manage or view details of existing webhooks configurations, or to create new webhook configurations."},{"name":"workspaces","description":"Use this resource to view details of provisioned workspaces, or to create new workspaces."}],"paths":{"/v1/workspaces/archive":{"put":{"tags":["workspaces"],"summary":"Archive a workspace","description":"Archive an inactive workspace using the specified workspace ID. When a workspace is archived, any cloud applications are disconnected, and Inbound Gateway and Network settings are cleared. Admin users can’t sign into archived workspaces, and archived workspaces don’t appear in an MSP's list of workspaces.","operationId":"archiveWorkspace","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"200":{"description":"Success","content":{"application/json":{}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/users":{"get":{"tags":["users"],"summary":"Retrieve users","description":"Retrieve a list of users in a workspace. This call supports pagination; default page size includes 20 users.","operationId":"searchUsers","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"email","in":"query","description":"Filter by a user’s email address. This is not case sensitive.","required":false,"schema":{"type":"string","description":"Filter by a user’s email address. This is not case sensitive."}},{"name":"name","in":"query","description":"Filter by a user’s name. This is not case sensitive.","required":false,"schema":{"type":"string","description":"Filter by a user’s name. This is not case sensitive."}},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/EndUserPageResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"put":{"tags":["users"],"summary":"Update user","description":"Update the details of a user.","operationId":"updateUser","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/EndUserRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/EndUserResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["users"],"summary":"Add protected users","description":"Add protected users to a workspace.","operationId":"addUsersForProtection","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddProtectedUsersRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddProtectedUsersResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/subscriptions":{"get":{"tags":["subscriptions"],"summary":"Retrieve the subscription of a specific workspace","description":"Retrieve the subscription details of a specific workspace, including the modules and add-ons that are enabled and disabled.","operationId":"getSubscriptionState","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubscriptionRequestResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"put":{"tags":["subscriptions"],"summary":"Update the subscription of a specific workspace","description":"Update the subscription of a specific workspace. Modifying your subscription alters your billing amount. Required modules and add-ons must be enabled. To get the details of which modules and add-ons must be enabled for different bundles offered by Coro, use the POST request to the /subscription endpoint.","operationId":"updateSubscriptionForWorkspace","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubscriptionRequestResponse"}}},"required":true},"responses":{"202":{"description":"Accepted","content":{"application/json":{"schema":{"type":"string","enum":["100 CONTINUE","101 SWITCHING_PROTOCOLS","102 PROCESSING","103 EARLY_HINTS","103 CHECKPOINT","200 OK","201 CREATED","202 ACCEPTED","203 NON_AUTHORITATIVE_INFORMATION","204 NO_CONTENT","205 RESET_CONTENT","206 PARTIAL_CONTENT","207 MULTI_STATUS","208 ALREADY_REPORTED","226 IM_USED","300 MULTIPLE_CHOICES","301 MOVED_PERMANENTLY","302 FOUND","302 MOVED_TEMPORARILY","303 SEE_OTHER","304 NOT_MODIFIED","305 USE_PROXY","307 TEMPORARY_REDIRECT","308 PERMANENT_REDIRECT","400 BAD_REQUEST","401 UNAUTHORIZED","402 PAYMENT_REQUIRED","403 FORBIDDEN","404 NOT_FOUND","405 METHOD_NOT_ALLOWED","406 NOT_ACCEPTABLE","407 PROXY_AUTHENTICATION_REQUIRED","408 REQUEST_TIMEOUT","409 CONFLICT","410 GONE","411 LENGTH_REQUIRED","412 PRECONDITION_FAILED","413 PAYLOAD_TOO_LARGE","413 REQUEST_ENTITY_TOO_LARGE","414 URI_TOO_LONG","414 REQUEST_URI_TOO_LONG","415 UNSUPPORTED_MEDIA_TYPE","416 REQUESTED_RANGE_NOT_SATISFIABLE","417 EXPECTATION_FAILED","418 I_AM_A_TEAPOT","419 INSUFFICIENT_SPACE_ON_RESOURCE","420 METHOD_FAILURE","421 DESTINATION_LOCKED","422 UNPROCESSABLE_ENTITY","423 LOCKED","424 FAILED_DEPENDENCY","425 TOO_EARLY","426 UPGRADE_REQUIRED","428 PRECONDITION_REQUIRED","429 TOO_MANY_REQUESTS","431 REQUEST_HEADER_FIELDS_TOO_LARGE","451 UNAVAILABLE_FOR_LEGAL_REASONS","500 INTERNAL_SERVER_ERROR","501 NOT_IMPLEMENTED","502 BAD_GATEWAY","503 SERVICE_UNAVAILABLE","504 GATEWAY_TIMEOUT","505 HTTP_VERSION_NOT_SUPPORTED","506 VARIANT_ALSO_NEGOTIATES","507 INSUFFICIENT_STORAGE","508 LOOP_DETECTED","509 BANDWIDTH_LIMIT_EXCEEDED","510 NOT_EXTENDED","511 NETWORK_AUTHENTICATION_REQUIRED"]}}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/subscriptions/stop":{"put":{"tags":["subscriptions"],"summary":"Stop subscription for the given workspace.","operationId":"stopSubscription","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"type":"string","enum":["100 CONTINUE","101 SWITCHING_PROTOCOLS","102 PROCESSING","103 EARLY_HINTS","103 CHECKPOINT","200 OK","201 CREATED","202 ACCEPTED","203 NON_AUTHORITATIVE_INFORMATION","204 NO_CONTENT","205 RESET_CONTENT","206 PARTIAL_CONTENT","207 MULTI_STATUS","208 ALREADY_REPORTED","226 IM_USED","300 MULTIPLE_CHOICES","301 MOVED_PERMANENTLY","302 FOUND","302 MOVED_TEMPORARILY","303 SEE_OTHER","304 NOT_MODIFIED","305 USE_PROXY","307 TEMPORARY_REDIRECT","308 PERMANENT_REDIRECT","400 BAD_REQUEST","401 UNAUTHORIZED","402 PAYMENT_REQUIRED","403 FORBIDDEN","404 NOT_FOUND","405 METHOD_NOT_ALLOWED","406 NOT_ACCEPTABLE","407 PROXY_AUTHENTICATION_REQUIRED","408 REQUEST_TIMEOUT","409 CONFLICT","410 GONE","411 LENGTH_REQUIRED","412 PRECONDITION_FAILED","413 PAYLOAD_TOO_LARGE","413 REQUEST_ENTITY_TOO_LARGE","414 URI_TOO_LONG","414 REQUEST_URI_TOO_LONG","415 UNSUPPORTED_MEDIA_TYPE","416 REQUESTED_RANGE_NOT_SATISFIABLE","417 EXPECTATION_FAILED","418 I_AM_A_TEAPOT","419 INSUFFICIENT_SPACE_ON_RESOURCE","420 METHOD_FAILURE","421 DESTINATION_LOCKED","422 UNPROCESSABLE_ENTITY","423 LOCKED","424 FAILED_DEPENDENCY","425 TOO_EARLY","426 UPGRADE_REQUIRED","428 PRECONDITION_REQUIRED","429 TOO_MANY_REQUESTS","431 REQUEST_HEADER_FIELDS_TOO_LARGE","451 UNAVAILABLE_FOR_LEGAL_REASONS","500 INTERNAL_SERVER_ERROR","501 NOT_IMPLEMENTED","502 BAD_GATEWAY","503 SERVICE_UNAVAILABLE","504 GATEWAY_TIMEOUT","505 HTTP_VERSION_NOT_SUPPORTED","506 VARIANT_ALSO_NEGOTIATES","507 INSUFFICIENT_STORAGE","508 LOOP_DETECTED","509 BANDWIDTH_LIMIT_EXCEEDED","510 NOT_EXTENDED","511 NETWORK_AUTHENTICATION_REQUIRED"]}}}}},"security":[{"JWT":[]}]}},"/v1/subscriptions/start":{"put":{"tags":["subscriptions"],"summary":"Start subscription for the given workspace.","operationId":"startSubscription","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"type":"string","enum":["100 CONTINUE","101 SWITCHING_PROTOCOLS","102 PROCESSING","103 EARLY_HINTS","103 CHECKPOINT","200 OK","201 CREATED","202 ACCEPTED","203 NON_AUTHORITATIVE_INFORMATION","204 NO_CONTENT","205 RESET_CONTENT","206 PARTIAL_CONTENT","207 MULTI_STATUS","208 ALREADY_REPORTED","226 IM_USED","300 MULTIPLE_CHOICES","301 MOVED_PERMANENTLY","302 FOUND","302 MOVED_TEMPORARILY","303 SEE_OTHER","304 NOT_MODIFIED","305 USE_PROXY","307 TEMPORARY_REDIRECT","308 PERMANENT_REDIRECT","400 BAD_REQUEST","401 UNAUTHORIZED","402 PAYMENT_REQUIRED","403 FORBIDDEN","404 NOT_FOUND","405 METHOD_NOT_ALLOWED","406 NOT_ACCEPTABLE","407 PROXY_AUTHENTICATION_REQUIRED","408 REQUEST_TIMEOUT","409 CONFLICT","410 GONE","411 LENGTH_REQUIRED","412 PRECONDITION_FAILED","413 PAYLOAD_TOO_LARGE","413 REQUEST_ENTITY_TOO_LARGE","414 URI_TOO_LONG","414 REQUEST_URI_TOO_LONG","415 UNSUPPORTED_MEDIA_TYPE","416 REQUESTED_RANGE_NOT_SATISFIABLE","417 EXPECTATION_FAILED","418 I_AM_A_TEAPOT","419 INSUFFICIENT_SPACE_ON_RESOURCE","420 METHOD_FAILURE","421 DESTINATION_LOCKED","422 UNPROCESSABLE_ENTITY","423 LOCKED","424 FAILED_DEPENDENCY","425 TOO_EARLY","426 UPGRADE_REQUIRED","428 PRECONDITION_REQUIRED","429 TOO_MANY_REQUESTS","431 REQUEST_HEADER_FIELDS_TOO_LARGE","451 UNAVAILABLE_FOR_LEGAL_REASONS","500 INTERNAL_SERVER_ERROR","501 NOT_IMPLEMENTED","502 BAD_GATEWAY","503 SERVICE_UNAVAILABLE","504 GATEWAY_TIMEOUT","505 HTTP_VERSION_NOT_SUPPORTED","506 VARIANT_ALSO_NEGOTIATES","507 INSUFFICIENT_STORAGE","508 LOOP_DETECTED","509 BANDWIDTH_LIMIT_EXCEEDED","510 NOT_EXTENDED","511 NETWORK_AUTHENTICATION_REQUIRED"]}}}}},"security":[{"JWT":[]}]}},"/v1/settings/webhooks/{id}":{"get":{"tags":["webhook-configuration"],"summary":"Retrieve a webhook configuration","description":"Retrieve the details of a webhook configurations in a specified workspace.","operationId":"getWebhookConfiguration","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WebhookConfigurationDto"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"put":{"tags":["webhook-configuration"],"summary":"Update a webhook configuration","description":"Update the details of a webhook configuration in a specified workspace.","operationId":"updateWebhookConfiguration","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateWebhookConfigurationRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WebhookConfigurationDto"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"delete":{"tags":["webhook-configuration"],"summary":"Delete a webhook configuration","description":"Delete a webhook configuration by its unique identifier. This action cannot be undone.","operationId":"deleteWebhookConfiguration","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"*/*":{"schema":{"type":"object"}}}}},"security":[{"JWT":[]}]}},"/v1/workspaces":{"get":{"tags":["workspaces"],"summary":"Retrieve a workspace","description":"Retrieve a workspace by its unique identifier.","operationId":"getWorkspace","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WorkspaceResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["workspaces"],"summary":"Create a workspace","description":"Create a new workspace. Each workspace represents a separate organization. Managed service providers (MSPs) can create child workspaces for each of their customers.","operationId":"createWorkspace","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateWorkspaceRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WorkspaceResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/{id}/actions":{"get":{"tags":["tickets"],"summary":"Get tickets actions","description":"Get tickets actions by ticket id.","operationId":"searchTicketActions","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"type":"string"}}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["tickets"],"summary":"Trigger a ticket action","description":"Trigger a ticket action by ticket id.","operationId":"triggerTicketAction","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketActionRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketActionsResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/subscriptions/bundleInfo":{"post":{"tags":["subscriptions"],"summary":"Retrieve the module and add-on details of specific bundles","description":"Retrieve the details of modules and add-ons included in specific bundles offered by Coro. These details can be used to update your subscription with the PUT request to the /subscription endpoint. Modifying your subscription alters your billing amount.","operationId":"getSubscriptionUpdateDto","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleRequestBody"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubscriptionRequestResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/settings/webhooks":{"get":{"tags":["webhook-configuration"],"summary":"Retrieve webhook configurations","description":"Retrieve a list of all the webhooks for a specified workspace.","operationId":"getAllWebhookConfigurations","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WebhookConfigurationDto"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["webhook-configuration"],"summary":"Create a webhook configuration","description":"Create a new webhook configuration for a specified workspace.","operationId":"createWebhookConfiguration","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateWebhookConfigurationRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WebhookConfigurationDto"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/portal-users":{"get":{"tags":["portal-users"],"summary":"Retrieve portal users","description":"Retrieve a list of admin portal users in a specified workspace. This call supports pagination; default page size includes 20 users.","operationId":"searchPortalUsers","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50},{"name":"email","in":"query","description":"Filter by an admin portal user's email address. This query is not case sensitive.","required":false,"schema":{"type":"string","description":"Filter by an admin portal user's email address. This query is not case sensitive."}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PortalUsersPageResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["portal-users"],"summary":"Add a portal user","description":"Add an admin portal user to a specified workspace. The user is assigned a super admin role.","operationId":"addPortalUser","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddPortalUserRequest"}}},"required":true},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddPortalUserResponse"}}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/devices/{enrollmentCode}/actions":{"get":{"tags":["devices"],"summary":"Retrieve supported actions for a device","description":"Retrieve all the supported actions that can be performed on a device through its enrollment code.","operationId":"getDeviceActions","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"enrollmentCode","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeviceActionsResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]},"post":{"tags":["devices"],"summary":"Perform an action on a device","description":"Perform a supported action on a device through its enrollment code.","operationId":"performDeviceAction","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"enrollmentCode","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SupportedDeviceActionsRequest"}}},"required":true},"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeviceActionResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/oauth/token":{"post":{"tags":["authentication"],"summary":"Authenticate users","description":"Authenticate the user before making other API calls. The token is valid for 24 hours.","operationId":"auth","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClientAuthRequest"}}},"required":true},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClientAuthResponse"}}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}}}},"/v1/workspaces/search":{"get":{"tags":["workspaces"],"summary":"Search for a workspace","description":"This endpoint can be used to search for a workspace which you have access to. The workspace header defines the parent workspace to search below.","operationId":"searchWorkspaces","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50},{"name":"search","in":"query","description":"Filter by id, display name, company name and domain. This is not case sensitive.","required":false,"schema":{"type":"string","description":"Filter by id, display name, company name and domain. This is not case sensitive."}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/users/{id}":{"get":{"tags":["users"],"summary":"Retrieve a user","description":"Retrieve a user by their unique identifier.","operationId":"searchUser","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/EndUserResponse"}}}}},"security":[{"JWT":[]}]},"delete":{"tags":["users"],"summary":"Delete a user","description":"Delete a user by their unique identifier. This action cannot be undone.","operationId":"removeUser","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json":{}}},"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/usage":{"get":{"tags":["usage"],"summary":"Retrieve usage","description":"Retrieve the usage of a workspace. This call supports pagination; default page size includes 20 entries.","operationId":"billingUsage","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"start","in":"query","description":"Filter by a start time, in UNIX format, including milliseconds.","required":true,"schema":{"type":"number","description":"Filter by a start time, in UNIX format, including milliseconds."}},{"name":"end","in":"query","description":"Filter by an end time, in UNIX format, including milliseconds.","required":true,"schema":{"type":"number","description":"Filter by an end time, in UNIX format, including milliseconds."}},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}},"content":{}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UsagePageResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets":{"get":{"tags":["tickets"],"summary":"Get a list of all tickets","description":"Get a list of all tickets in the specified workspace. This call supports pagination; default page size includes 20 tickets.","operationId":"searchTickets","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"ticketIds","in":"query","required":false,"schema":{"uniqueItems":true,"type":"array","items":{"type":"string","description":"Search by ticket ids"}}},{"name":"ticketTriggers","in":"query","required":false,"schema":{"uniqueItems":true,"type":"array","items":{"$ref":"#/components/schemas/EventTriggerDto"}}},{"name":"processed","in":"query","description":"Search by processed flag","required":false,"schema":{"type":"boolean","description":"Search by processed flag"}},{"name":"fromTime","in":"query","description":"Search for tickets that were occurred after this timestamp in milliseconds","required":false,"schema":{"type":"number","description":"Search for tickets that were occurred after this timestamp in milliseconds"}},{"name":"toTime","in":"query","description":"Search for tickets that were occurred before this timestamp in milliseconds","required":false,"schema":{"type":"number","description":"Search for tickets that were occurred before this timestamp in milliseconds"}},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketPageResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/{id}":{"get":{"tags":["tickets"],"summary":"Get a ticket","description":"Get a ticket by ticket id.","operationId":"searchTicket","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketResponse"}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/summary/users":{"get":{"tags":["tickets-summary"],"summary":"Retrieve users and tickets","description":"Retrieve a summary of users and associated tickets for a workspace. The summary includes the total number of open tickets, closed tickets, users with associated tickets, and users with no associated tickets.","operationId":"getProtectedUsersSummary","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"resolvedFromTime","in":"query","description":"Enter the date starting from which to return the summary in UNIX format, including milliseconds. For example: `1662376467` represents Sept. 5, 2022 at 11:14:28 GMT. The response returns the last 3 months of ticket data by default if no value is sent for timestamp.","required":false,"schema":{"type":"integer","format":"int64","default":1763424000000}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProtectedUsersSummaryResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/summary/emails":{"get":{"tags":["tickets-summary"],"summary":"Retrieve emails and tickets","description":"Retrieve a summary of emails and associated tickets for a workspace. The summary includes the total number of open tickets, closed tickets, emails with associated tickets, and emails with no associated tickets.","operationId":"getEmailsSummary","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"resolvedFromTime","in":"query","description":"Enter the date starting from which to return the summary in UNIX format, including milliseconds. For example: `1662376467` represents Sept. 5, 2022 at 11:14:28 GMT. The response returns the last 3 months of ticket data by default if no value is sent for timestamp.","required":false,"schema":{"type":"integer","format":"int64","default":1763424000000}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/EmailsSummaryResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/summary/devices":{"get":{"tags":["tickets-summary"],"summary":"Retrieve devices and tickets","description":"Retrieve a summary of devices and associated tickets for a workspace. The summary includes the total number of open tickets, closed tickets, devices with associated tickets, and devices with no associated tickets.","operationId":"getDevicesSummary","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"resolvedFromTime","in":"query","description":"Enter the date starting from which to return the device summary in UNIX format, including milliseconds. For example: `1662376467` represents Sept. 5, 2022 at 11:14:28 GMT. The response returns the last 3 months of ticket data by default if no value is sent for timestamp.","required":false,"schema":{"type":"integer","format":"int64","default":1763424000000}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DevicesSummaryResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/summary/data":{"get":{"tags":["tickets-summary"],"summary":"Retrieve data and tickets","description":"Retrieve a summary of monitored data and associated tickets for a workspace. The summary includes the total number of open tickets, closed tickets, monitored data with associated tickets, and monitored data with no associated tickets.","operationId":"getDataSummary","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"resolvedFromTime","in":"query","description":"Enter the date starting from which to return the summary in UNIX format, including milliseconds. For example: `1662376467` represents Sept. 5, 2022 at 11:14:28 GMT. The response returns the last 3 months of ticket data by default if no value is sent for timestamp.","required":false,"schema":{"type":"integer","format":"int64","default":1763424000000}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DataSummaryResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/tickets/summary/cloud-apps":{"get":{"tags":["tickets-summary"],"summary":"Retrieve apps and tickets","description":"Retrieve a summary of protected cloud apps and associated tickets for a workspace. The summary includes the total number of open tickets, closed tickets, cloud apps with associated tickets, and cloud apps with no associated tickets.","operationId":"getCloudAppsSummary","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"resolvedFromTime","in":"query","description":"Enter the date starting from which to return the summary in UNIX format, including milliseconds. For example: `1662376467` represents Sept. 5, 2022 at 11:14:28 GMT. The response returns the last 3 months of ticket data by default if no value is sent for timestamp.","required":false,"schema":{"type":"integer","format":"int64","default":1763424000000}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CloudAppsSummaryResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/settings/webhooks/{id}/test":{"get":{"tags":["webhook-configuration"],"summary":"Test a webhook configuration","description":"Test that a webhook can be sent successfully","operationId":"testWebhookConfiguration","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}},{"name":"trigger","in":"query","required":false,"schema":{"type":"string"}},{"name":"version","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"*/*":{"schema":{"type":"string","enum":["100 CONTINUE","101 SWITCHING_PROTOCOLS","102 PROCESSING","103 EARLY_HINTS","103 CHECKPOINT","200 OK","201 CREATED","202 ACCEPTED","203 NON_AUTHORITATIVE_INFORMATION","204 NO_CONTENT","205 RESET_CONTENT","206 PARTIAL_CONTENT","207 MULTI_STATUS","208 ALREADY_REPORTED","226 IM_USED","300 MULTIPLE_CHOICES","301 MOVED_PERMANENTLY","302 FOUND","302 MOVED_TEMPORARILY","303 SEE_OTHER","304 NOT_MODIFIED","305 USE_PROXY","307 TEMPORARY_REDIRECT","308 PERMANENT_REDIRECT","400 BAD_REQUEST","401 UNAUTHORIZED","402 PAYMENT_REQUIRED","403 FORBIDDEN","404 NOT_FOUND","405 METHOD_NOT_ALLOWED","406 NOT_ACCEPTABLE","407 PROXY_AUTHENTICATION_REQUIRED","408 REQUEST_TIMEOUT","409 CONFLICT","410 GONE","411 LENGTH_REQUIRED","412 PRECONDITION_FAILED","413 PAYLOAD_TOO_LARGE","413 REQUEST_ENTITY_TOO_LARGE","414 URI_TOO_LONG","414 REQUEST_URI_TOO_LONG","415 UNSUPPORTED_MEDIA_TYPE","416 REQUESTED_RANGE_NOT_SATISFIABLE","417 EXPECTATION_FAILED","418 I_AM_A_TEAPOT","419 INSUFFICIENT_SPACE_ON_RESOURCE","420 METHOD_FAILURE","421 DESTINATION_LOCKED","422 UNPROCESSABLE_ENTITY","423 LOCKED","424 FAILED_DEPENDENCY","425 TOO_EARLY","426 UPGRADE_REQUIRED","428 PRECONDITION_REQUIRED","429 TOO_MANY_REQUESTS","431 REQUEST_HEADER_FIELDS_TOO_LARGE","451 UNAVAILABLE_FOR_LEGAL_REASONS","500 INTERNAL_SERVER_ERROR","501 NOT_IMPLEMENTED","502 BAD_GATEWAY","503 SERVICE_UNAVAILABLE","504 GATEWAY_TIMEOUT","505 HTTP_VERSION_NOT_SUPPORTED","506 VARIANT_ALSO_NEGOTIATES","507 INSUFFICIENT_STORAGE","508 LOOP_DETECTED","509 BANDWIDTH_LIMIT_EXCEEDED","510 NOT_EXTENDED","511 NETWORK_AUTHENTICATION_REQUIRED"]}}}}},"security":[{"JWT":[]}]}},"/v1/portal-users/{id}":{"get":{"tags":["portal-users"],"summary":"Retrieve a portal user","description":"Retrieve an admin portal user by their unique identifier.","operationId":"getPortalUser","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PortalUserResponse"}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/devices":{"get":{"tags":["devices"],"summary":"Retrieve protected devices","description":"Retrieve the protected devices in a workspace. This call supports pagination; default page size includes 20 devices.","operationId":"searchDevices","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"},{"name":"enrollmentCode","in":"query","description":"Filter by Coro’s unique enrollment code for a device.","required":false,"schema":{"type":"string","description":"Filter by Coro’s unique enrollment code for a device."}},{"name":"page","in":"query","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","required":false,"schema":{"minimum":0,"type":"string","description":"API responses use pagination to reduce loading time. Return a specific page of results, using a zero-based page index (0..N).","example":0,"default":"0"},"example":0},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page.","example":50,"default":"20"},"example":50}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DevicePageResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/devices/agents/latest":{"get":{"tags":["devices"],"summary":"Retrieve latest Coro Agents","description":"Retrieve a list of the latest Coro Agent versions available for supported device operating systems. Each URL is specific to the workspace.","operationId":"listLatestStableDeviceAgents","parameters":[{"name":"Workspace","in":"header","description":"The workspace identifier, which isolates API requests inside the provided workspace scope.","required":true,"schema":{"type":"string"},"example":"corodevonmicrosoftcom_TX7T_u"}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeviceAgentsResponse"}}}}},"security":[{"JWT":[]}]}},"/v1/audit-logs/search":{"get":{"tags":["audit-logs"],"summary":"Get a list of audit logs","description":"Get a list of all audit logs in the specified workspace. This call supports pagination; default page size includes 20 logs.","operationId":"searchAuditLogs","parameters":[{"name":"Workspace","in":"header","required":true,"schema":{"type":"string"}},{"name":"ticketIds","in":"query","required":false,"schema":{"type":"array","items":{"type":"string","description":"One or more ticket IDs to filter by.","example":"GYDU-1212"}}},{"name":"remediation","in":"query","description":"Filter by whether the log was part of a remediation action.","required":false,"schema":{"type":"boolean","description":"Filter by whether the log was part of a remediation action.","example":true},"example":true},{"name":"fromTime","in":"query","description":"Start date/time (inclusive) in milliseconds.","required":false,"schema":{"type":"number","description":"Start date/time (inclusive) in milliseconds.","example":1754047435131},"example":1754047435131},{"name":"toTime","in":"query","description":"End date/time (inclusive) in milliseconds.","required":false,"schema":{"type":"number","description":"End date/time (inclusive) in milliseconds.","example":1754047575801},"example":1754047575801},{"name":"types","in":"query","required":false,"schema":{"type":"array","items":{"type":"string","description":"The list of types to filter by.","example":"detectionLogs","enum":["account","cloudApps","device","dlp","deviceDlp","email","malware","phishing","undo","users","billing","detectionLogs","csvExport","workspace","msp","siemConfigs","apiCredentials","workspaceReport","workspaceScheduledReport","soc","mobile","psa","webhook","mdmSystem","mdmAction","mdmDevice","mdmDeviceAction","securityAwareness","mspPolicy","securityGaps","syslogConfigs"]}}},{"name":"subTypes","in":"query","required":false,"schema":{"type":"array","items":{"type":"string","description":"The list of sub types to filter by.","example":"markAsUnprocessed","enum":["treatAsSafe","treatAsMalicious","removeFromAllowlist","removeFromBlocklist","usersCreation","groupsCreation","malwareSettings","phishingSettings","emailSettings","deviceSettings","devicePostureSettings","dataLossSettings","dataLossWizardSettings","dataLossScanScheduleSettings","deviceEventsActions","suspendUserFromService","suspendUserFromAllServices","removeFromProtection","uninstallAgent","allowNoEncryption","markAsProcessed","markAsUnprocessed","mfaConfigUpdate","mfaLogin","approveFile","deleteFile","moveToSuspectedFolder","logForAuditReports","unLogForAuditReports","contactUser","approveEmail","deleteBackupFilesPrevented","malwareFileQuarantined","infectedProcessTerminated","blockProcess","unblockProcess","allowProcess","enableNetworkBlockMode","disableNetworkBlockMode","shutdownDevice","rebootDevice","networkSettings","roleChange","restoreBlockedEmailFromStorage","failToRestoreEmailFromStorage","deleteBlockedEmailFromStorage","blockedEmail","suspectedEmail","proxySettings","download","siemConfig","firewallSettings","siteToSiteTunnels","swg","dns","ztna","mfaNetwork","importClassificationsCsv","archiveWorkspace","unarchiveWorkspace","mobileInvite","mobileActivate","mobileVerify","mobileDeactivate","mobileSessionRevoke","mobileMergeDevices","psa","securityAwarenessModule","securityAwarenessPhishingSimulations","securityAwarenessTrainings","securityGapFix","securityGapRecalculate","edrSettings"]}}},{"name":"autoGenerated","in":"query","description":"Filter by whether the log was auto generated.","required":false,"schema":{"type":"boolean","description":"Filter by whether the log was auto generated.","example":true},"example":true},{"name":"pageSize","in":"query","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page. Used only for the very first request subsequent request should use cursor value","required":false,"schema":{"maximum":500,"minimum":10,"type":"string","description":"API responses use pagination to reduce loading time. Return a maximum of this many items per page. Used only for the very first request subsequent request should use cursor value","example":50,"default":"20"},"example":50},{"name":"cursor","in":"query","description":"A base64-encoded pagination cursor used to retrieve a specific page of results. This value should be taken from the nextPage or prevPage field in a previous response. If omitted, the API returns the first page of results. Use this parameter to navigate forward or backward through paginated data.","required":false,"schema":{"type":"string","description":"A base64-encoded pagination cursor used to retrieve a specific page of results. This value should be taken from the nextPage or prevPage field in a previous response. If omitted, the API returns the first page of results. Use this parameter to navigate forward or backward through paginated data.","example":"eyJzIjoxLCJwIjowfQ=="},"example":"eyJzIjoxLCJwIjowfQ=="}],"responses":{"400":{"description":"Bad request, validation error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestErrorResponse"}}}},"429":{"description":"Too Many Requests","headers":{"X-Rate-Limit-Retry-After-Seconds":{"description":"Indicates how many seconds API client has to wait in order to make a request again","style":"simple","schema":{}},"X-Rate-Limit-Limit":{"description":"The maximum number of requests available in the current time frame","style":"simple","schema":{}}}},"500":{"description":"Internal server error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorResponse"}}}},"403":{"description":"Access forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ForbiddenErrorResponse"}}}},"401":{"description":"Unauthorized request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedErrorResponse"}}}},"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuditLogPageResponse"}}}}},"security":[{"JWT":[]}]}}},"components":{"schemas":{"BadRequestErrorResponse":{"type":"object","properties":{"status":{"type":"integer","description":"The HTTP status code","format":"int32","example":400},"title":{"type":"string","description":"Human-readable summary of the problem. It is not changing from occurrence to occurrence of the problem","example":"Bad request"},"errors":{"type":"array","items":{"type":"string","description":"Error details (e.g. fields validation message)","example":"Workspace: missing mandatory request header"}},"timestamp":{"type":"string","description":"Error time in ISO 8601 format","format":"date-time","example":"2022-08-21T19:44:32.351Z"},"traceId":{"type":"string","description":"Error unique identifier","example":"a029fd656529d7dc"}}},"InternalServerErrorResponse":{"type":"object","properties":{"status":{"type":"integer","description":"The HTTP status code","format":"int32","example":500},"title":{"type":"string","description":"Human-readable summary of the problem. It is not changing from occurrence to occurrence of the problem","example":"Internal Server Error"},"timestamp":{"type":"string","description":"Error time in ISO 8601 format","format":"date-time","example":"2022-08-21T19:44:32.351Z"},"traceId":{"type":"string","description":"Error unique identifier","example":"a029fd656529d7dc"}}},"ForbiddenErrorResponse":{"type":"object","properties":{"status":{"type":"integer","description":"The HTTP status code","format":"int32","example":403},"title":{"type":"string","description":"Human-readable summary of the problem. It is not changing from occurrence to occurrence of the problem","example":"Forbidden"},"timestamp":{"type":"string","description":"Error time in ISO 8601 format","format":"date-time","example":"2022-08-21T19:44:32.351Z"},"traceId":{"type":"string","description":"Error unique identifier","example":"a029fd656529d7dc"}}},"UnauthorizedErrorResponse":{"type":"object","properties":{"status":{"type":"integer","description":"The HTTP status code","format":"int32","example":401},"title":{"type":"string","description":"Human-readable summary of the problem. It is not changing from occurrence to occurrence of the problem","example":"Unauthorized"},"timestamp":{"type":"string","description":"Error time in ISO 8601 format","format":"date-time","example":"2022-08-21T19:44:32.351Z"},"traceId":{"type":"string","description":"Error unique identifier","example":"a029fd656529d7dc"}}},"EndUserRequest":{"required":["email","protectedUser"],"type":"object","properties":{"email":{"type":"string","description":"The user's email address.","example":"corotest@corotest.com"},"protectedUser":{"type":"boolean","description":"The protection status of the user.","example":true}}},"EndUserResponse":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier of the user.","example":"62ff9653efef4b3ae04ab25e"},"email":{"type":"string","description":"The user’s email address.","example":"test@test.com"},"name":{"type":"string","description":"The user’s full name.","example":"Harry Owen"},"protectedUser":{"type":"boolean","description":"The protection status of the user."}}},"AddonDto":{"type":"object","properties":{"name":{"type":"string","enum":["inboundGateway","wifiPhishing","securedMessages","mdr","socCloudSecurity","socEndpointSecurity","socEmailSecurity","socUserDataGovernance","socEndpointDataGovernance","socNetwork","zeroTrustNetworkAccess","outboundGateway"]},"enabled":{"type":"boolean"}}},"SecurityModuleDto":{"type":"object","properties":{"enabled":{"type":"boolean"},"addons":{"uniqueItems":true,"type":"array","items":{"$ref":"#/components/schemas/AddonDto"}}}},"SubscriptionModules":{"type":"object","properties":{"cloudSecurity":{"$ref":"#/components/schemas/SecurityModuleDto"},"endpointSecurity":{"$ref":"#/components/schemas/SecurityModuleDto"},"emailSecurity":{"$ref":"#/components/schemas/SecurityModuleDto"},"userDataGovernance":{"$ref":"#/components/schemas/SecurityModuleDto"},"endpointDataGovernance":{"$ref":"#/components/schemas/SecurityModuleDto"},"edr":{"$ref":"#/components/schemas/SecurityModuleDto"},"network":{"$ref":"#/components/schemas/SecurityModuleDto"},"securedWebGateway":{"$ref":"#/components/schemas/SecurityModuleDto"},"mdm":{"$ref":"#/components/schemas/SecurityModuleDto"},"securityAwareness":{"$ref":"#/components/schemas/SecurityModuleDto"}}},"SubscriptionRequestResponse":{"type":"object","properties":{"modules":{"$ref":"#/components/schemas/SubscriptionModules"},"bundles":{"uniqueItems":true,"type":"array","items":{"type":"string","enum":["endpointProtection","managedEndpointProtection","emailProtection","managedEmailProtection","sase","managedSase","coroEssentials","managedCoroEssentials","coroClassic","managedCoroClassic","coroComplete","managedCoroComplete","coroAIEssentials","managedCoroAIEssentials","coroAIEndpoint","managedCoroAIEndpoint","coroAIComplete","managedCoroAIComplete"]}}}},"UpdateWebhookConfigurationRequest":{"required":["applyToAllDescendants","name","secret","status","triggers","url"],"type":"object","properties":{"name":{"type":"string","description":"<placeholder>"},"description":{"type":"string","description":"<placeholder>"},"applyToAllDescendants":{"type":"boolean","description":"<placeholder>"},"url":{"type":"string","description":"<placeholder>"},"secret":{"type":"string","description":"<placeholder>"},"headers":{"type":"object","additionalProperties":{"type":"string","description":"<placeholder>"},"description":"<placeholder>"},"triggers":{"uniqueItems":true,"type":"array","description":"<placeholder>","items":{"type":"string","description":"<placeholder>","enum":["workspaceCreated.v1","workspaceStatusUpdated.v1","subscriptionUpdated.v1","protectedUsersAdded.v1","protectedUsersUpdated.v1","protectedUsersDeleted.v1","protectedDevicesUpdated.v1","protectedDevicesAdded.v1","protectedDevicesDeleted.v1","protectedDevicesCountUpdated.v1"]},"enum":["workspaceCreated.v1","workspaceStatusUpdated.v1","subscriptionUpdated.v1","protectedUsersAdded.v1","protectedUsersUpdated.v1","protectedUsersDeleted.v1","protectedDevicesUpdated.v1","protectedDevicesAdded.v1","protectedDevicesDeleted.v1","protectedDevicesCountUpdated.v1"]},"status":{"type":"string","description":"<placeholder>","enum":["enabled","disabled"]}}},"WebhookConfigurationDto":{"required":["triggers"],"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"workspaceId":{"type":"string"},"status":{"type":"string","description":"<placeholder>","enum":["enabled","disconnected","disabled"]},"description":{"type":"string"},"applyToAllDescendants":{"type":"boolean"},"url":{"type":"string"},"secret":{"type":"string"},"headers":{"type":"object","additionalProperties":{"type":"string"}},"triggers":{"uniqueItems":true,"type":"array","description":"<placeholder>","items":{"type":"string","description":"<placeholder>","enum":["workspaceCreated","workspaceStatusUpdated","subscriptionUpdated","protectedUsersAdded","protectedUsersUpdated","protectedUsersDeleted","protectedDevicesUpdated"]},"enum":["workspaceCreated","workspaceStatusUpdated","subscriptionUpdated","protectedUsersAdded","protectedUsersUpdated","protectedUsersDeleted","protectedDevicesUpdated"]},"created":{"type":"integer","format":"int64"},"updated":{"type":"integer","format":"int64"}}},"CreateWorkspaceRequest":{"required":["adminEmail","companyName","displayName","domain","notificationsLevel","type"],"type":"object","properties":{"companyName":{"type":"string","description":"The name of the company for which the workspace is created.","example":"Company Name"},"displayName":{"type":"string","description":"The name displayed for the workspace from the user interface.","example":"Child workspace"},"type":{"type":"string","description":"The type of workspace to be created. Types include: regular, for individual companies, channel for the MSP parent level, and child for MSP customers.","example":"child","enum":["regular","channel","child"]},"domain":{"type":"string","description":"The workspace domain.","example":"child-workspace.com"},"adminEmail":{"type":"string","description":"The email address of the admin portal user who manages the workspace.","example":"admin@child-workspace.com"},"maxProtectedUsers":{"minimum":0,"type":"integer","description":"The maximum number of protected users allowed in the workspace.","format":"int32","example":25},"notificationsLevel":{"type":"string","description":"The workspace admin portal users who receive notifications.","example":"all","default":"all","enum":["none","parent","localAdmins","all"]}}},"WorkspaceResponse":{"required":["companyName","displayName","domain","id","type"],"type":"object","properties":{"id":{"type":"string","description":"The unique identifier of the workspace.","example":"corodevonmicrosoftcom_EZ90_b"},"companyName":{"type":"string","description":"The name of the company.","example":"Company Name"},"displayName":{"type":"string","description":"The name displayed for the workspace from the user interface.","example":"Child workspace"},"type":{"type":"string","description":"The type of workspace.","example":"child","enum":["regular","channel","child"]},"domain":{"type":"string","description":"The workspace domain.","example":"child-workspace.com"},"maxProtectedUsers":{"type":"integer","description":"The maximum number of protected users allowed in the workspace.","format":"int32","example":25},"notificationsLevel":{"type":"string","description":"The workspace admin portal users who receive notifications.","example":"none","enum":["none","parent","localAdmins","all"]},"parentWorkspaceId":{"type":"string","description":"The unique identifier of the parent/channel workspace.","example":"coroparent_123"},"protectedDevices":{"type":"integer","description":"The number of protected devices in the workspace.","format":"int32"},"children":{"uniqueItems":true,"type":"array","description":"A list of any child workspaces provisioned for this workspace.","items":{"type":"string","description":"A list of any child workspaces provisioned for this workspace."}},"mainAdminEmail":{"type":"string","description":"The admin portal user email address provided when the workspace was created."},"adminEmails":{"uniqueItems":true,"type":"array","description":"The email addresses of all admin portal users associated with the workspace.","items":{"type":"string","description":"The email addresses of all admin portal users associated with the workspace."}},"pendingAdminEmails":{"uniqueItems":true,"type":"array","description":"The email addresses of all pending admins associated with the workspace.","items":{"type":"string","description":"The email addresses of all pending admins associated with the workspace."}},"lastAdminLoginTime":{"type":"integer","description":"The most recent login to the workspace by an admin user, in UNIX format, including milliseconds.","format":"int64","example":1693562400000},"workspaceCreationTime":{"type":"integer","description":"The date the workspace was created, in UNIX format, including milliseconds.","format":"int64","example":1641009600000},"workspaceCreationType":{"type":"string","description":"Defines the method and creator of the workspace.<br>\n* msp – Workspace created via the MSP portal by a user with the MSP role.<br>\n* internal – Workspace created via the MSP portal by a user with the Global role.<br>\n* api – Workspace provisioned through the API.<br>\n* direct – Workspace created via the self-serv
[...]
